"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.MuiProvider = void 0;
var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));
var _react = _interopRequireDefault(require("react"));
var _styles = require("@mui/material/styles");
var _materialUiConfirm = require("material-ui-confirm");
var _LocalizationProvider = require("@mui/x-date-pickers/LocalizationProvider");
var _AdapterMoment = require("@mui/x-date-pickers/AdapterMoment");
var _package = _interopRequireDefault(require("@mui/x-date-pickers/package.json"));
var _CssVarsProvider = require("./CssVarsProvider");
var _theming = require("../../utils/theming");
var _split$, _xdpPackage$version; // TODO: set moment to dayjs
// to determine version
// eslint-disable-next-line @typescript-eslint/no-unsafe-member-access
var xdpVersion = parseInt((_split$ = (_xdpPackage$version = _package["default"].version) === null || _xdpPackage$version === void 0 || (_xdpPackage$version = _xdpPackage$version.split(".")) === null || _xdpPackage$version === void 0 ? void 0 : _xdpPackage$version[0]) !== null && _split$ !== void 0 ? _split$ : "0");
var MuiProvider = exports.MuiProvider = function MuiProvider(_ref) {
  var _config$settings$loca, _config$settings$desi;
  var config = _ref.config,
    children = _ref.children;
  var momentLocale = (_config$settings$loca = config.settings.locale) === null || _config$settings$loca === void 0 ? void 0 : _config$settings$loca.moment;
  var existingOuterTheme = (0, _styles.useTheme)();
  var existingTheme = (_config$settings$desi = config.settings.designSettings) !== null && _config$settings$desi !== void 0 && _config$settings$desi.canInheritThemeFromOuterProvider ? existingOuterTheme : undefined;
  var mergedTheme = _react["default"].useMemo(function () {
    return (0, _theming.buildTheme)(config, existingTheme);
  }, [config, existingTheme]);
  var locProviderProps = momentLocale ? xdpVersion >= 6 ? {
    locale: momentLocale
  } : {
    adapterLocale: momentLocale
  } : {};
  var withProviders = /*#__PURE__*/_react["default"].createElement(_LocalizationProvider.LocalizationProvider, (0, _extends2["default"])({
    dateAdapter: _AdapterMoment.AdapterMoment
  }, locProviderProps), /*#__PURE__*/_react["default"].createElement(_materialUiConfirm.ConfirmProvider, null, /*#__PURE__*/_react["default"].createElement(_CssVarsProvider.CssVarsProvider, {
    config: config
  }, children)));
  var withTheme = mergedTheme ? /*#__PURE__*/_react["default"].createElement(_styles.ThemeProvider, {
    theme: mergedTheme
  }, withProviders) : withProviders;
  return withTheme;
};