"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));
var _react = _interopRequireWildcard(require("react"));
var _TextField = _interopRequireDefault(require("@mui/material/TextField"));
var _FormControl = _interopRequireDefault(require("@mui/material/FormControl"));
var _InputAdornment = _interopRequireDefault(require("@mui/material/InputAdornment"));
var _ui = require("@react-awesome-query-builder/ui");
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != _typeof(e) && "function" != typeof e) return { "default": e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n["default"] = e, t && t.set(e, n), n; }
var _Utils$NumberFormat = _ui.Utils.NumberFormat,
  NumericFormat = _Utils$NumberFormat.NumericFormat,
  getNumberFormatProps = _Utils$NumberFormat.getNumberFormatProps;
var _default = exports["default"] = function _default(props) {
  var value = props.value,
    setValue = props.setValue,
    readonly = props.readonly,
    min = props.min,
    max = props.max,
    step = props.step,
    placeholder = props.placeholder,
    customProps = props.customProps,
    prefix = props.prefix,
    suffix = props.suffix;
  var numericFormatProps = getNumberFormatProps(props, ["prefix", "suffix"]);
  var handleChange = function handleChange(values) {
    var val = values.floatValue;
    setValue(val === undefined ? null : val);
  };
  var formattedValue = value == undefined ? "" : value;
  var InputProps = (0, _react.useMemo)(function () {
    return {
      readOnly: readonly,
      startAdornment: prefix != undefined ? /*#__PURE__*/_react["default"].createElement(_InputAdornment["default"], {
        position: "start"
      }, prefix) : undefined,
      endAdornment: suffix != undefined ? /*#__PURE__*/_react["default"].createElement(_InputAdornment["default"], {
        position: "end"
      }, suffix) : undefined
    };
  }, [readonly]);

  // will not work without prop type="number"
  // const inputProps = useMemo(
  //   () => ({
  //     min,
  //     max,
  //   }),
  //   [min, max, step]
  // );

  return /*#__PURE__*/_react["default"].createElement(_FormControl["default"], null, /*#__PURE__*/_react["default"].createElement(NumericFormat, (0, _extends2["default"])({
    size: "small",
    customInput: _TextField["default"],
    value: formattedValue,
    placeholder: !readonly ? placeholder : "",
    InputProps: InputProps
    //inputProps={inputProps}
    ,
    disabled: readonly,
    onValueChange: handleChange,
    variant: "standard"
    //type="number"
  }, customProps, numericFormatProps)));
};